#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <errno.h>

#include <sys/stat.h>
//#include <sys/sched.h>
//#include <sys/qnx_glob.h>

#define SPWN_F (_SPAWN_NOZOMBIE | _SPAWN_NOHUP | _SPAWN_NEWPGRP | \
				_SPAWN_BGROUND | _SPAWN_TCSETPGRP | _SPAWN_SETSID)

int main(int argc, char **argv, char **arge)
{
	struct stat st;
	int i;
	pid_t pid;

	setsid();
	setgid(0);

	if (argc < 4)
	{
		printf("Usage: %s <wait path> <shell> <params>\n", argv[0]);
		return(-1);
	}

	printf("Waiting for %s...", argv[1]);
	fflush(stdout);
	while(stat(argv[1], &st))
	{
		printf("...");
		fflush(stdout);
		sleep(1);
	}

	printf("\nSpawning %s\n", argv[2]);
	fflush(stdout);

	if ((pid = qnx_spawn(1, NULL, 0, -1, -1, SPWN_F, argv[2], &argv[2], arge, NULL, -1)) == -1)
	{
		printf("Spawn error (code: %d)\n", errno);
		return(1);
	}

	return(0);
}
